//--------------------------------------------------------//
// This is part of the program Lan painter                //
// Copyright (C) Olexandr Polyeno (polyenoom@gmail.com)   //
// License LGPL (http://www.gnu.org/copyleft/lesser.html) //
//--------------------------------------------------------//

#include "c_add_pc.h"
#include <QtGui>
#include "member.h"

c_add_pc::c_add_pc(Member* mem, QString lang, QWidget *parent):QDialog(parent)
{
	//i18n
	QTranslator translator;
	translator.load(lang, ":/translations"); 
	qApp->installTranslator(&translator);
	//
	QVBoxLayout* pvbox=new QVBoxLayout;
	peditpc=new QLineEdit;
	peditip=new QLineEdit;
	connect(peditpc, SIGNAL(returnPressed()),this, SLOT(slot_change_record()));
	connect(peditip, SIGNAL(returnPressed()),this, SLOT(slot_change_record()));
	lwg=new QListWidget;
	QListWidgetItem* pitem=0;
	m=mem;
	if(mem->get_n_pcs()>0)
	{
		for(int i=0;i<mem->get_n_pcs();i++)
		{
			pitem=new QListWidgetItem(mem->get_pc(i)+" ("+mem->get_ip(mem->get_pc(i))+")", lwg);
		}
		peditpc->setText(mem->get_pc(0));
		//lwg->s
	}
	
	QLabel* pnlabel=new QLabel(tr("<html><table width=\"100%\"><tr><td><hr></td><td>Switch name = ")+ mem->get_name().mid(1,mem->get_name().length()-1)+"</td></tr></table></html>");
	pvbox->addWidget(pnlabel);
	
	pvbox->addWidget(lwg);
	
	QLabel* plblpc=new QLabel(tr("Name:"));
	QLabel* plblip=new QLabel(tr("ip:"));
	
	QHBoxLayout* phbox=new QHBoxLayout;
	phbox->addWidget(plblpc);
	phbox->addWidget(peditpc);
	phbox->addWidget(plblip);
	phbox->addWidget(peditip);
	phbox->setMargin(2);
	pvbox->addLayout(phbox);
	pvbox->setMargin(5);
	
	
	QHBoxLayout* phboxcmd=new QHBoxLayout;
	QPushButton* pcmddel=new QPushButton(tr("Delete"));
	connect(pcmddel, SIGNAL(clicked()),this, SLOT(slot_delete_record()));
	QPushButton* pcmdadd=new QPushButton(tr("Add"));
	connect(pcmdadd, SIGNAL(clicked()),this, SLOT(slot_change_record()));
	QPushButton* pcmdexit=new QPushButton(tr("Exit"));
	connect(pcmdexit,SIGNAL(clicked()),this,SLOT(close()));
	phboxcmd->addWidget(pcmdexit);
	phboxcmd->addStretch();
	phboxcmd->addWidget(pcmddel);
	phboxcmd->setMargin(2);
    phboxcmd->addWidget(pcmdadd);
    pvbox->addLayout(phboxcmd);
    
    connect(lwg,SIGNAL(itemClicked(QListWidgetItem*)),this, SLOT(slot_item_clicked(QListWidgetItem*)));
    
	setLayout(pvbox);
	
	setTabOrder(peditpc, peditip);
	setTabOrder(peditip, pcmdadd);
	setTabOrder(pcmdadd, pcmddel);
	setTabOrder(pcmddel,pcmdexit);
	
	peditpc->setFocus();
	
	setWindowTitle(tr("Edit pcs"));
}

void c_add_pc::slot_item_clicked(QListWidgetItem* item)
{
	QString ip;
	peditpc->setText(item->text().split(" ")[0]);
	ip=item->text().split(" ")[1];
	peditip->setText(ip.mid(1,ip.length()-2));
}

void c_add_pc::slot_delete_record()
{
	QList<QListWidgetItem*> lst;
	lst= lwg->findItems(peditpc->text()+" ("+peditip->text()+")", Qt::MatchExactly);
	if(!(lst.isEmpty()))
	{
		delete lst[0];
		m->del_pc(peditpc->text());
		emit signal_redraw_members();
	}
}
	
void c_add_pc::slot_change_record()
{
	QList<QListWidgetItem*> lst;
	QListWidgetItem* temp_item;
	QString name, ip;
	name=peditpc->text();
	while(name.indexOf(" ")!=-1)
	{
		name.replace(name.indexOf(" "), 1, "_");	
	}
	peditpc->setText(name);
	lst= lwg->findItems(name, Qt::MatchStartsWith);
	if(!(lst.isEmpty()))
	{
		delete lst[0];
		m->del_pc(name);
	}
	
	ip=peditip->text();
	while(ip.indexOf(" ")!=-1)
	{
		ip.replace(ip.indexOf(" "), 1, ".");	
	}
	while(ip.indexOf(":")!=-1)
	{
		ip.replace(ip.indexOf(":"), 1, ".");	
	}
	while(ip.indexOf("-")!=-1)
	{
		ip.replace(ip.indexOf("-"), 1, ".");	
	}
	peditip->setText(ip);
	QRegExp reg("^[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}$");
	if(reg.indexIn(ip)==0)
	{
		m->add_pc_ip(name, ip);
		temp_item=new QListWidgetItem(name+" ("+ip+")", lwg);
	}
	else
	{
		m->add_pc_ip(name, "");
		temp_item=new QListWidgetItem(name+" ()", lwg);
	}
	
	emit signal_redraw_members();
	peditpc->setFocus();
}
